{$A+,B-,E-,F-,G+,I-,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$D-,L-,Y-}
{$M 65520,0,655360}

{============Spezifikation============}

const
n=8;
k=10;                    {$DEFINE K10}
s=2;                     {$DEFINE S2}
catname='mech_8.kat';

{=====================================}

var
StoreStart,StoreEnd, {Adressen von Anfang und Ende des Typenspeichers}
StoreN: word; {Adresse des nchsten zu speichernden Typs}

function Store (StoreN: word; ID: comp): boolean; assembler;
{sucht den Typ ID im Typenspeicher, Rckgabewert ob neuer Typ,
falls neu, wird ID dem Typenspeicher hinzugefgt}
asm
mov cx,[bp+4] {ID Wort 0}
mov si,[bp+6] {ID Wort 1}
mov di,[bp+8] {ID Wort 2}
push ds
mov bx,StoreStart
cmp bx,StoreN
jz @E {Typenspeicher leer}
push bp
mov bp,[bp+10] {ID Wort 3}
@W: mov ax,12; mul bx; mov bx,ax; and bx,15
  ror dx,4; shr ax,4; add ax,dx; mov ds,ax {ds:bx := 12*bx}
  cmp bp,[bx+10]; jb @L; ja @R
  cmp di,[bx+8]; jb @L; ja @R
  cmp si,[bx+6]; jb @L; ja @R
  cmp cx,[bx+4]; jb @L; jbe @X {Vergleich ID mit [ds:bx]}
  @R: add bx,2 {ID>[ds:bx], rechter Unterbaum}
  @L: cmp word ptr [bx],0
    jz @N {Unterbaum leer, Abstieg abbrechen}
    mov bx,[bx] {weiter absteigen}
    jmp @W
@N: pop bp
  mov ax,StoreN
  mov [bx],ax {neuen Unterbaum anlegen}
@E: mov ax,12; mul StoreN; mov bx,ax; and bx,15
  ror dx,4; shr ax,4; add ax,dx; mov ds,ax {ds:bx := 12*StoreN}
  mov word ptr [bx],0
  mov word ptr [bx+2],0 {beide Unterbume leer}
  mov [bx+4],cx
  mov [bx+6],si
  mov [bx+8],di
  mov ax,[bp+10]
  mov [bx+10],ax {[ds:bx] := ID}
  mov ax,1 {Typ neu, Rckgabewert TRUE}
  jmp @P
@X: pop bp
mov ax,0 {Typ gefunden, Rckgabewert FALSE}
@P:pop ds
end; {Store}

type
nBytes=array [0..n-1] of byte;
nWords=array [0..n-1] of word;
kBytes=array [0..k-1] of byte;
kWords=array [0..k-1] of word;

tree=record sub0, sub1: word; data: comp end;

var
a,b: kBytes;
{Gelenke einer Struktur, Gelenk x verbindet Glieder a [x] und b [x]}
ab: kWords;
{Gelenke einer Struktur, ab [x] = 2^a [x] + 2^b [x]}

function TypeID: comp;
{berechnet Typencode der durch a und b festgelegten Struktur}
var
x,j,jc1: integer;
perm,max,eq: nBytes;
c0: nWords; {c0 [x] = maximale Gelenknummern an Glied x, die noch
  extremal sein knnen (Bitmap)}
jc: kBytes;
ID,bc: comp;

  procedure Determine (nr: integer; var max0,eq0: nBytes);
  {Whlt Glieder nr und darunter aus, Ergebnis steht in perm}
  var
  link,grp,j,x,c,best,minc: integer;
  max,eq: nBytes; {Gruppen, nach Auswahl modifiziert}
  cnt: array [0..n-1] of nBytes; {cnt [i,j] - Anzahl der mit Glied i
    verbundenen Glieder, die zur Gruppe ..j gehren}

  begin
  best:=0;
  minc:=c0 [nr]; {Minimum der parallelen Flle mu erreicht werden}
  fillchar (cnt,sizeof (cnt),0);
  for j:=0 to k-1 do
    begin
    inc (cnt [a [j],max0 [b [j]]]);
    inc (cnt [b [j],max0 [a [j]]])
    end;

  for link:=s to n-1 do if max0 [link]=nr then
    begin
    c:=0;
    for grp:=0 to n-1 do if cnt [link,grp]>0 then
      begin x:=1 shl (grp-eq0 [grp]+1); inc (c,x shl cnt [link,grp]-x) end;
      {c := minimal mgliche Gelenknummern als Bitfeld}
    if c=minc then inc (best,1 shl link)
      {gleich mit bisherigem Minimum, zur Auswahl hinzunehmen}
    else if c<minc then begin best:=1 shl link; minc:=c end
      {geringer als bisheriges Minimum, alleinige neue Auswahl}
    end;
  if minc<c0 [nr] then
    begin c0 [nr]:=minc; if nr>0 then c0 [nr-1]:=maxint end;
    {Minimum fr parallele Flle merken}

  if best>0 then for link:=s to n-1 do if best and (1 shl link)>0 then
    begin {Glied link bekommt Nummer nr}
    max:=max0;
    eq:=eq0;

    {durch Verbindung von Gliedern mit Glied link hervorgerufene Spaltung von
    Gruppen berechnen:}
    for j:=0 to k-1 do
      begin
      x:=255;
      if a [j]=link then x:=b [j] else if b [j]=link then x:=a [j];
      if (x<255) and (cnt [link,max [x]]<eq [max [x]]) then
        dec (max [x],eq [max [x]]-cnt [link,max [x]]);
          {Glied x ist mit link verbunden, also in neue Gruppe verschieben,
          um minimale Gelenknummern bei link zu erreichen}
      end;
    for grp:=0 to n-1 do
      if (cnt [link,grp]>0) and (cnt [link,grp]<eq [grp]) then
        begin {Gruppengren korrigieren}
        dec (eq [grp],cnt [link,grp]); {alte Gruppe}
        eq [grp-eq [grp]]:=cnt [link,grp] {neue Gruppe}
        end;

    {Gliednummer nr zuweisen, bisherige Gruppe aufspalten:}
    for x:=s to n-1 do if (x<>link) and (max [x]=nr) then dec (max [x]);
      {x konnte bisher Nummer nr erhalten, jetzt nicht mehr}
    if eq [nr]>1 then begin eq [nr-1]:=eq [nr]-1; eq [nr]:=1 end;
      {Gruppengre korrigieren}

    if nr=s then perm:=max {Zuweisung der Nummern fertig}
    else Determine (nr-1,max,eq) {sonst mit nchster Nummer fortfahren}
    end
  end; {Determine}

begin {TypeID}
c0 [n-1]:=maxint; {noch keine Flle behandelt, alles mglich}
fillchar (max,sizeof (max),n-1);
eq [n-1]:=n-s; {am Anfang alle Glieder in Gruppe ..n-1}
for x:=0 to s-1 do {auer nicht vertauschbaren}
  begin max [x]:=x; eq [x]:=1 end;
Determine (n-1,max,eq); {extremale Gliednummern ermitteln}

for j:=0 to k-1 do
  begin
  if perm [a [j]]<perm [b [j]] then
    jc1:=perm [a [j]]+perm [b [j]]*(perm [b [j]]-1) div 2
  else jc1:=perm [b [j]]+perm [a [j]]*(perm [a [j]]-1) div 2;
    {jc1 := Gelenkcode von Gelenk j}
  x:=0; while (x<j) and (jc1>jc [x]) do inc (x);
  move (jc [x],jc [x+1],j-x); jc [x]:=jc1; {jc1 in jc einsortieren}
  end;

ID:=0;
for j:=0 to k-1 do if jc [j]>0 then
  begin bc:=1; for x:=0 to j do bc:=bc*(jc [j]-x)/(x+1); ID:=ID+bc end;
  {ID komprimieren}
TypeID:=ID
end; {TypeID}

{fehlende Optionen erzeugen:}
{$IFDEF K19} {$DEFINE K18} {$ENDIF}
{$IFDEF K18} {$DEFINE K17} {$ENDIF}
{$IFDEF K17} {$DEFINE K16} {$ENDIF}
{$IFDEF K16} {$DEFINE K15} {$ENDIF}
{$IFDEF K15} {$DEFINE K14} {$ENDIF}
{$IFDEF K14} {$DEFINE K13} {$ENDIF}
{$IFDEF K13} {$DEFINE K12} {$ENDIF}
{$IFDEF K12} {$DEFINE K11} {$ENDIF}
{$IFDEF K11} {$DEFINE K10} {$ENDIF}
{$IFDEF K10} {$DEFINE K9} {$ENDIF}
{$IFDEF K9} {$DEFINE K8} {$ENDIF}
{$IFDEF K8} {$DEFINE K7} {$ENDIF}
{$IFDEF K7} {$DEFINE K6} {$ENDIF}
{$IFDEF K6} {$DEFINE K5} {$ENDIF}

var
OkSub: array [0..8191] of word; {zu prfende Teilketten}
OkMax: array [0..8191] of byte; {maximale Gelenkzahlen der Teilketten}
OkN: integer; {Anzahl der zu prfenden Teilketten}

function Ok: boolean; assembler;
{prft, ob die durch ab festgelegt Struktur starre Teilketten enthlt,
wenn ja, Rckgabewert FALSE, sonst TRUE}
asm
mov ax,0
{$IFDEF S1} mov bx,1 shl n -1 {$ELSE} mov di,OkN {$ENDIF}
@1: {$IFNDEF S1} shl di,1
  mov bx,[offset OkSub+di]
  shr di,1 {$ENDIF}
  mov dl,k
      test bx,[offset ab+00]; jz @A; dec dl
  @A: test bx,[offset ab+02]; jz @B; dec dl
  @B: test bx,[offset ab+04]; jz @C; dec dl
  @C: test bx,[offset ab+06]; jz @D; dec dl
  @D: {$IFDEF K5} test bx,[offset ab+08]; jz @E; dec dl
  @E: {$ENDIF} {$IFDEF K6} test bx,[offset ab+10]; jz @F; dec dl
  @F: {$ENDIF} {$IFDEF K7} test bx,[offset ab+12]; jz @G; dec dl
  @G: {$ENDIF} {$IFDEF K8} test bx,[offset ab+14]; jz @H; dec dl
  @H: {$ENDIF} {$IFDEF K9} test bx,[offset ab+16]; jz @I; dec dl
  @I: {$ENDIF} {$IFDEF K10} test bx,[offset ab+18]; jz @J; dec dl
  @J: {$ENDIF} {$IFDEF K11} test bx,[offset ab+20]; jz @K; dec dl
  @K: {$ENDIF} {$IFDEF K12} test bx,[offset ab+22]; jz @L; dec dl
  @L: {$ENDIF} {$IFDEF K13} test bx,[offset ab+24]; jz @M; dec dl
  @M: {$ENDIF} {$IFDEF K14} test bx,[offset ab+26]; jz @N; dec dl
  @N: {$ENDIF} {$IFDEF K15} test bx,[offset ab+28]; jz @O; dec dl
  @O: {$ENDIF} {$IFDEF K16} test bx,[offset ab+30]; jz @P; dec dl
  @P: {$ENDIF} {$IFDEF K17} test bx,[offset ab+32]; jz @Q; dec dl
  @Q: {$ENDIF} {$IFDEF K18} test bx,[offset ab+34]; jz @R; dec dl
  @R: {$ENDIF} {$IFDEF K19} test bx,[offset ab+36]; jz @i2; dec dl
  @i2: {$ENDIF} {$IFDEF S1} cmp dl,[offset OkMax+bx]
    {$ELSE} cmp dl,[offset OkMax+di] {$ENDIF}
  ja @X
  {$IFDEF S1} dec bx {$ELSE} dec di {$ENDIF}
  jns @1
mov ax,1
@X:
end; {Ok}

procedure InitOk; assembler;
{Initialisierung der Testfelder fr Prozedur Ok}
asm
mov di,0
mov bx,1 shl n -1
@1: mov ax,1 shl n -1; sub ax,bx
  mov dx,0
  mov cx,n
  @2: shr ax,1; adc dx,0; dec cx; jnz @2
{$IFNDEF S1} mov cx,dx; mov ax,1; shl ax,cl
  test ax,101010100000b and (1 shl (n-2)-1)
  jz @3 {$ENDIF}
    mov ax,dx; add ax,dx; add ax,dx; shr ax,1; dec ax; dec ax
{$IFDEF S1} mov [offset OkMax+bx],al
{$ELSE} mov [offset OkMax+di],al
    shl di,1; mov [offset OkSub+di],bx; shr di,1
    inc di {$ENDIF}
  @3: dec bx
  jnz @1
{$IFDEF S1} mov byte ptr [offset OkMax],255
{$ELSE} dec di; mov OkN,di {$ENDIF}
end; {InitOk}

var
ExTypes, {Anzahl der ausgelagerten Typen}
enull: longint;
Temp: integer; {spezifiziert Typen-Auslagerungsdatei}
cat: file;

{$S+}
procedure Save (final: boolean);
{legt den Inhalt des Typenspeichers in Datei ab,
bereits ausgelagerte Typen werden zugemischt,
wenn final=TRUE, anhngen an Katalog-Datei cat,
sonst Auslagern in temporre Datei, deren Gre steht dann in ExTypes}
var
fsrc,fdst: file; {Quell- und Zieldatei}
pfdst:^file;
next: comp; {nchster einzumischender ausgelagerter Typ}

  procedure SaveTree (pos: word);
  {schreibt Typen aus Baum mit Wurzel bei Adresse pos in Datei pfdst^,
  falls Temp>0, werden Typen aus Datei fsrc zugemischt}
  var p: ^tree;
  begin
  if pos=0 then exit;
  p:=ptr (longint (pos)*12 shr 4,longint (pos)*12 and 15);
  SaveTree (p^.sub0); {kleineren Unterbaum behandeln}
  if Temp>0 then while next<=p^.data do
    begin {ausgelagerte Typen einmischen}
    if next<p^.data then begin blockwrite (pfdst^,next,1); inc (ExTypes) end;
      {bei Gleichheit ausgelagerten Typ berspringen}
    if EOF (fsrc) then next:=9E18 else blockread (fsrc,next,1);
      {nchsten ausgelagerten Typ lesen}
    end;
  blockwrite (pfdst^,p^.data,1); inc (ExTypes); {Typ aus der Wurzel schreiben}
  SaveTree (p^.sub1) {greren Unterbaum behandeln}
  end; {SaveTree}

begin {Save}
if Temp>0 then {bereits Auslagerung vorgenommen}
  begin
  assign (fsrc,'synth'+char (48+Temp)+'.tmp'); reset (fsrc,8);
  blockread (fsrc,next,1); {ersten ausgelagerten Typ lesen}
  end;
if final then pfdst:=@cat
else
  begin
  ExTypes:=0;
  assign (fdst,'synth'+char (49+Temp and 1)+'.tmp'); rewrite (fdst,8);
  pfdst:=@fdst
  end;
if StoreN<>StoreStart then SaveTree (StoreStart);
  {wenn Typenspeicher nicht leer, gesamten Speicher sichern}
if Temp>0 then
  begin {restliche ausgelagerte Typen bertragen}
  while next<9E18 do
    begin
    blockwrite (pfdst^,next,1); inc (ExTypes);
    if EOF (fsrc) then next:=9E18 else blockread (fsrc,next,1)
    end;
  close (fsrc);
  end;
if not final then begin close (fdst); Temp:=Temp and 1 +1 end
  {Auslagerung abwechselnd in 'synth1.tmp' und 'synth2.tmp'}
end; {Save}
{$S-}

procedure Search (link0: integer; var conn0: nBytes; var joint0,
  opt0: nWords);
{erzeugt alle Typen mit:
link0 = erstes Glied, das noch nicht vollstndig verbunden ist
conn0 [x] = Anzahl von Gliedern, die noch mit Glied x verbunden werden mssen
joint0 [x] = Glieder, die bereits mit Glied x verbunden sind (Bitfeld)
opt0 [x] = Glieder, die noch mit Glied x verbunden werden knnen (Bitfeld)}
var
link1,x,y,j: integer;
conn: nBytes;
joint, opt: nWords;

begin
{erstes noch mit Glied link0 verbundenes Glied auswhlen:}
for link1:=link0+1 to n-1 do
  if ((1 shl link1) and opt0 [link0]>0)
      {link1 kann mit link0 verbunden werden}
    and (conn0 [link1]>0) {link1 ist noch nicht vollstndig verbunden}
    and ((link1=s) or (link1=link0+1) or (conn0 [link1]<>conn0 [link1-1])
    or (joint0 [link1]<>joint0 [link1-1])) then
      {gleichartige Glieder nur einmal betrachten}

    begin {Glied link1 mit Glied link0 verbinden}
    conn:=conn0; joint:=joint0; opt:=opt0;
    for x:=link0+1 to link1-1 do
      if joint [link0] and (1 shl x)>0 then
        opt [x]:=opt [x] and not (1 shl link1);
          {starre Dreiecke verhindern}
    inc (joint [link0],1 shl link1); dec (conn [link0]);
    inc (joint [link1],1 shl link0); dec (conn [link1]);
    opt [link0]:=opt [link0] and not (1 shl (link1+1)-1);
      {keine Glieder bis link1 knnen mehr mit link0 verbunden werden}
    x:=link0; while (conn [x]=0) and (x<n-1) do inc (x);
      {nchstes Glied suchen, das noch nicht vollstndig verbunden ist}

    if x<n-1 then Search (x,conn,joint,opt)
      {weitere Glieder sind zu verbinden}
    else if conn [n-1]=0 then
      begin {alle Glieder sind vollstndig verbunden}
      {Gelenkinformationen a, b und ab aus joint ermitteln:}
      j:=0;
      for x:=0 to n-1 do for y:=x+1 to n-1 do
        if joint [x] and (1 shl y)>0 then
          begin a [j]:=x; b [j]:=y; ab [j]:=1 shl x+1 shl y; inc (j) end;
      if ((OkN<0) or Ok) and Store (StoreN,TypeID) then
        {Test auf starre Teilketten und auf redundante Typen}
        begin
        inc (StoreN);
        if StoreN=StoreEnd then begin Save (FALSE); StoreN:=StoreStart end;
          {wenn Speicher voll, Typen auslagern}
        end
      end
    end;
end; {Search}

var
cat1: file;
conn: nBytes;
cnull: array [0..15-n] of byte;
joint, opt: nWords;
x,reduce,rest,maxconn: integer;
total: longint; {Anzahl der Typen insgesamt}
header: record b: array [0..3] of byte; l: longint end;
c: comp;

begin
{Typenspeicher im Heap platzieren:}
StoreStart:=longint (seg (heaporg^))*16 div 12+1;
StoreEnd:=longint (seg (heapend^))*16 div 12;
writeln ('RAM capacity: ',StoreEnd-StoreStart,' types');

InitOk;
enull:=0;
fillchar (cnull,16-n,0);
total:=0;
assign (cat,'synth.tmp'); rewrite (cat,8);

{Mechanismen, zwei nicht vertauschbare Glieder:}
{$IFDEF S2} for conn [0]:=1+2*k-2*n downto 1 do
for conn [1]:=2+2*k-2*n-conn [0] downto 1 do
  begin
  fillchar (conn [3],n-3,2);
  conn [2]:=4+2*k-2*n-conn [0]-conn [1]; {erste Gelenkverteilung festlegen}
  repeat
    fillchar (joint,sizeof (joint),0);
    fillchar (opt,sizeof (opt),255);
    joint [0]:=2; joint [1]:=1;
    opt [0]:=1 shl n -3; {$ENDIF}

{Assur-Gruppen, ein nicht vertauschbares Glied:}
{$IFDEF S1} for conn [0]:=2+2*k-2*n downto 2 do
  begin
  fillchar (conn [2],n-2,2);
  conn [1]:=4+2*k-2*n-conn [0]; {erste Gelenkverteilung festlegen}
  repeat
    fillchar (joint,sizeof (joint),0);
    fillchar (opt,sizeof (opt),255); {$ENDIF}

{kinematische Ketten, alle Glieder vertauschbar:}
{$IFDEF S0} begin
  fillchar (conn [1],n-1,2);
  conn [0]:=2+2*k-2*n; {erste Gelenkverteilung festlegen}
  repeat
    fillchar (joint,sizeof (joint),0);
    fillchar (opt,sizeof (opt),255); {$ENDIF}

    write (total,' types found, analyse joint distribution ');
    for x:=0 to n-2 do write (conn [x],'-');
    write (conn [n-1],'    '#13);
    StoreN:=StoreStart; {Typenspeicher leer}
    Temp:=0; {noch keine Typen ausgelagert}
    Search (0,conn,joint,opt);
    if (StoreN>StoreStart) or (Temp>0) then
      begin
      if Temp>0 then begin Save (FALSE); StoreN:=StoreStart end
      else ExTypes:=StoreN-StoreStart;
      inc (total,ExTypes);
      blockwrite (cat,conn,2); {Gelenkverteilung speichern}
      blockwrite (cat,ExTypes,1); {Anzahl der Typen speichern}
      Save (TRUE);
      end;

    {nchste Gelenkverteilung ermitteln:}
    reduce:=n-1;
    rest:=1;
    while (reduce>s-1) and (conn [reduce]<4) do
      begin inc (rest,conn [reduce]-2); conn [reduce]:=2; dec (reduce) end;
        {zu reduzierendes Glied suchen, berschssige Gelenke zhlen}
    if reduce=s-1 then break; {alle Verteilungen betrachtet}
    dec (conn [reduce]); {Glied reduzieren}
    maxconn:=conn [reduce]; {maximale Gelenkzahl der folgenden Glieder}
    {berschssige Gelenke verteilen:}
    while rest>=conn [reduce]-2 do
      begin inc (reduce); conn [reduce]:=maxconn; dec (rest,maxconn-2) end;
    conn [reduce+1]:=rest+2;
  until FALSE;
  end;
close (cat);

{Datei um Katalog-Informationen ergnzen:}
assign (cat1,catname); rewrite (cat1,8);
header.b [0]:=99; header.b [1]:=n; header.b [2]:=k; header.b [3]:=s;
header.l:=total;
blockwrite (cat1,header,1);
reset (cat,8);
while not EOF (cat) do begin blockread (cat,c,1); blockwrite (cat1,c,1) end;
close (cat1);
close (cat);

writeln (total,' types found, '
  +'algorithm complete                                        '#7);
end.
