{$A+,B-,E-,F-,G+,I-,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$D-,L-,Y-}
{$M 16384,0,0}

const
catname='kett_12.kat';

type
nBytes=array [0..13] of byte;
nWords=array [0..13] of word;
kBytes=array [0..18] of byte;

var
a,b: kBytes;
{Gelenke einer Struktur, Gelenk x verbindet Glieder a [x] und b [x]}
code: comp; {komprimierter Typencode}
total: longint; {Anzahl der Typen insgesamt}
n,k: integer;

procedure Count;
{zhlt Anzahl der Mechanismen-Typen, die aus der durch a und b festgelegten
kinematischen Kette durch Wahl von Gelenk und Antrieb gebildet werden knnen}
var
fix,inp,x,y,j,conn,s: integer;
invperm,max,eq: nBytes;
c0, {c0 [x] = maximale Gelenknummern an Glied x, die noch
  extremal sein knnen (Bitmap)}
class,class0: nWords;
ok,first: boolean;

  procedure Determine (nr: integer; var max0,eq0: nBytes);
  {Whlt Glieder nr und darunter aus und verfolgt Gliederklassen in class}
  var
  link,grp,j,x,c,best,minc: integer;
  max,eq: nBytes; {Gruppen, nach Auswahl modifiziert}
  cnt: array [0..13] of nBytes; {cnt [i,j] - Anzahl der mit Glied i
    verbundenen Glieder, die zur Gruppe ..j gehren}

  begin
  best:=0;
  minc:=c0 [nr]; {Minimum der parallelen Flle mu erreicht werden}
  fillchar (cnt,sizeof (cnt),0);
  for j:=0 to k-1 do
    begin
    inc (cnt [a [j],max0 [b [j]]]);
    inc (cnt [b [j],max0 [a [j]]])
    end;

  for link:=0 to n-1 do if max0 [link]=nr then
    begin
    c:=0;
    for grp:=0 to n-1 do if cnt [link,grp]>0 then
      begin x:=1 shl (grp-eq0 [grp]+1); inc (c,x shl cnt [link,grp]-x) end;
      {c := minimal mgliche Gelenknummern als Bitfeld}
    if c=minc then inc (best,1 shl link)
      {gleich mit bisherigem Minimum, zur Auswahl hinzunehmen}
    else if c<minc then begin best:=1 shl link; minc:=c end
      {geringer als bisheriges Minimum, alleinige neue Auswahl}
    end;
  if minc<c0 [nr] then
    begin c0 [nr]:=minc; if nr>0 then c0 [nr-1]:=maxint; first:=TRUE end;
    {Minimum fr parallele Flle merken}

  if best>0 then for link:=n-1 downto 0 do if best and (1 shl link)>0 then
    begin {Glied link bekommt Nummer nr}
    max:=max0;
    eq:=eq0;

    {durch Verbindung von Gliedern mit Glied link hervorgerufene Spaltung von
    Gruppen berechnen:}
    for j:=0 to k-1 do
      begin
      x:=255;
      if a [j]=link then x:=b [j] else if b [j]=link then x:=a [j];
      if (x<255) and (cnt [link,max [x]]<eq [max [x]]) then
        dec (max [x],eq [max [x]]-cnt [link,max [x]]);
          {Glied x ist mit link verbunden, also in neue Gruppe verschieben,
          um minimale Gelenknummern bei link zu erreichen}
      end;
    for grp:=0 to n-1 do
      if (cnt [link,grp]>0) and (cnt [link,grp]<eq [grp]) then
        begin {Gruppengren korrigieren}
        dec (eq [grp],cnt [link,grp]); {alte Gruppe}
        eq [grp-eq [grp]]:=cnt [link,grp] {neue Gruppe}
        end;

    {Gliednummer nr zuweisen, bisherige Gruppe aufspalten:}
    for x:=0 to n-1 do if (x<>link) and (max [x]=nr) then dec (max [x]);
      {x konnte bisher Nummer nr erhalten, jetzt nicht mehr}
    if eq [nr]>1 then begin eq [nr-1]:=eq [nr]-1; eq [nr]:=1 end;
      {Gruppengre korrigieren}

    if nr=s then
      begin {Zuweisung der Nummern fertig}
      for x:=0 to n-1 do
        if first then begin class [x]:=x; invperm [max [x]]:=x end
          {einfache Klassen und Basispermutation festlegen}
        else if class [x]<class [invperm [max [x]]] then
          class [invperm [max [x]]]:=class [x]
        else class [x]:=class [invperm [max [x]]];
          {Glied x hat die Nummer bekommen, die in der Basispermutation
          Glied invperm [max [x]] bekam. Beide kommen nun in die gleiche
          (niedrigere) Klasse.}
      first:=FALSE
      end
    else Determine (nr-1,max,eq) {sonst mit nchster Nummer fortfahren}
    end
  end; {Determine}

begin {Count}
c0 [n-1]:=maxint; {noch keine Flle behandelt, alles mglich}
fillchar (max,sizeof (max),n-1);
s:=0; eq [n-1]:=n; {alle Glieder vertauschbar, in Gruppe ..n-1}
Determine (n-1,max,eq); {Gliederklassen ermitteln}

class0:=class;
for fix:=0 to n-1 do if class0 [fix]=fix then
  begin {Glied fix wird Gestell}
  class:=class0;

  {Ermitteln der mit dem Gestell verbundenen Glieder:}
  conn:=0;
  for j:=0 to k-1 do
    if a [j]=fix then conn:=conn or (1 shl b [j])
    else if b [j]=fix then conn:=conn or (1 shl a [j]);
  {Umbenennen der Gliederklassen, so da mit Gestell verbundene Glieder
  als Namen bevorzugt werden:}
  for x:=0 to n-1 do
    if ((1 shl x) and conn>0) and ((1 shl class [x]) and conn=0) then
      for y:=n-1 downto x do if class [y]=class [x] then class [y]:=x;

  {Test, ob alle potentiellen Antriebe verschiedenen Klassen angehren:}
  ok:=TRUE;
  for x:=0 to n-1 do
    if ((1 shl x) and conn>0) and (class [x]<>x) then ok:=FALSE;
  {falls nicht, berprfung der Gliederklassen notwendig:}
  if not ok then
    begin
    c0 [n-1]:=maxint; {noch keine Flle behandelt, alles mglich}
    fillchar (max,sizeof (max),n-1);
    max [fix]:=0; eq [0]:=1; {Gestell bekommt Nummer 0}
    s:=1; eq [n-1]:=n-1; {restliche Glieder vertauschbar, in Gruppe ..n-1}
    Determine (n-1,max,eq); {neue Gliederklassen ermitteln}
    end;

  for inp:=0 to n-1 do
    if ((1 shl inp) and conn>0) and (class [inp]=inp) then inc (total);
    {mgliche Glieder fr Antrieb zhlen}
  end;
end; {Count}

procedure decode;
{berechnet a und b aus code}
var
bc: comp;
j,jc: longint;

begin
for j:=k-1 downto 0 do
  begin
  if code=0 then jc:=j
  else
    begin
    jc:=j+1;
    bc:=1;
    while bc*(jc+1)/(jc-j)<=code do
      begin bc:=bc*(jc+1)/(jc-j); inc (jc) end;
    code:=code-bc;
    end;
  a [j]:=jc; b [j]:=1;
  while a [j]>=b [j] do begin dec (a [j],b [j]); inc (b [j]) end
  end;
end; {decode}

var
header: record b: array [0..3] of byte; l: longint end;
i,nl,ng: longint;
cat: file;

begin
assign (cat,catname); reset (cat,8);
blockread (cat,header,1);
n:=header.b [1]; k:=header.b [2];
total:=0;
ng:=0;
while not EOF (cat) do
  begin
  blockread (cat,code,1); blockread (cat,code,1);
    {Information ber Gelenkverteilung, wird nicht bentigt}
  blockread (cat,code,1); nl:=round (code);
    {nl = Anzahl der Kettentypen fr diese Gelenkverteilung}
  for i:=1 to nl do begin blockread (cat,code,1); decode; Count end;
    {Mechanismen-Typen fr die nl Kettentypen zhlen}
  inc (ng,nl);
  write (ng,' chain types considered, ',total,
    ' mechanism types derived'#13);
  end;
close (cat);
writeln;
writeln ('algorithm complete'#7);
end.
